import java.util.*;

public class OptimalPlayer extends GreedyPlayer {

	boolean output=true;
	
	OptimalPlayer(String name)
	{
		super(name);
	}
	
	public double computeCardPathPossibility(Card[] totalgame, int currindex, int round, int roundplayer, Vector cardsleft, boolean initiative)
	{
		double probability = 1;
		//We compute the chance that we WIN.
		// The probability that this card will win, or will remain winning.
		if (round >= 4)
		{
			if (initiative)
				probability *= (1-computeCardBeatPossibility(totalgame,currindex,round,0,(Card) cardsleft.get(0)));
			else
				probability *= computeCardRegainPossibility(totalgame,currindex,round,0, (Card) cardsleft.get(0));
		}
		else
		{
			for (int i=1; i<cardsleft.size(); i++);
		}
		
	
		/*if (round < 4)
			for (int i=1; i<cardsleft.size(); i++)
			{	
				// We want the chance that we will win, so we'll multiply the chances that we will not win.
				double notwinchance = 1;
				// Chance that we have initiative, times the chance that we will retain initiative.
				notwinchance *= 1-(probability * computeCardPathPossibility(totalgame,currindex,round+1,0,makeRemainingCardVector(cardsleft,(Card) cardsleft.get(i)),true));
				// Chance that we not have initiative, times the chance that we will regain initiative.
				probability *=  1 -((1-probability) * computeCardPathPossibility(totalgame,currindex,round+1,0,makeRemainingCardVector(cardsleft,(Card) cardsleft.get(i)),false));
			}*/
		
		// We return the slinking probability that nobody gets in between.
		/*if (cardsleft.size() == 1 )
			return (1-computeCardBeatPossibility(totalgame,currindex,4-cardsleft.size(),0,(Card) cardsleft.get(0)));*/
		//	possibility = possibility * ;
		
		
		// Let's see what this does.
		
		return probability;
	}
	
	// Warning, this will destroy the first card.
	public Vector makeRemainingCardVector(Vector cardsIn, Card card)
	{
		Vector cards = new Vector(cardsIn);
		//Card temp;
		int origindex = cards.indexOf(card);
		//temp= (Card) cards.get(0);
		//cards.remove(0);
		cards.set(0,card);
		cards.remove(origindex);
		
		return cards;
	}
	
	public Card computeLowestWinChance(Card[] totalgame, int currindex, int round, int roundplayer, Vector cards)
	{
		double lowestwinchance = 2;
		int winchanceindex=-1;
		for (int j=0; j<cards.size(); j++)
		{
			double winChance = computeCardPathPossibility(totalgame,currindex,round+1,0,cards,false);
			if ( winChance < lowestwinchance)
			{
				lowestwinchance = winChance;
				winchanceindex = j;	
			}
			
			if (output)
				System.out.println("   WinChance: "+((Card) cards.get(j)).getDescription()+" "+winChance);
		}
		
		return (Card) cards.get(winchanceindex);
	}
	
	
	public Card drawCard(String newOwner,  Card[] totalgame, int currindex, int round, int roundplayer)
	{
		if (output)
		{
			System.out.println("	"+name+":: Ik heb nog:  in round"+round);
			for (int i=0; i<cards.size(); i++)
				System.out.println("	"+((Card) cards.get(i)).getDescription());
		}
		
		Card card = null;
		
		int highestWinChangeIndex = -1;
		double highestWinChance = -1;
		for (int j=0; j<cards.size(); j++)
		{
			double winChance = computeCardPathPossibility(totalgame,currindex,round+1,roundplayer,makeRemainingCardVector(cards,(Card) cards.get(j)),true);
			if ( winChance > highestWinChance)
			{
					highestWinChance = winChance;
					highestWinChangeIndex = j;
			}
			if (output)
			{
				System.out.println("   Winchance!:"+((Card) cards.get(j)).getDescription()+" "+winChance);
			}
		}
		
		card = (Card) cards.get(highestWinChangeIndex);
		
		/*int suit = whichSuit(totalgame,currindex,round,roundplayer);
		Vector possibleCards = possibleCards(suit);
		Vector possibleWincards=possibleWinCards(suit);
		Card card = null;
		
		if (possibleWincards.size() == 0)
		{
			if (possibleCards.size() == 0)
				card = computeLowestWinChance(totalgame,currindex,round+1,0,cards);
			else
				card = computeLowestWinChance(totalgame,currindex,round+1,0,possibleCards);
		}
		else
		{
			//			 Compute for every card, the chance that it will win.
			int highestWinChangeIndex = -1;
			double highestWinChance = -1;
			
			// TODO
			for (int j=0; j<possibleWincards.size(); j++)
			{
				double winChance = computeCardPathPossibility(totalgame,currindex,round+1,roundplayer,makeRemainingCardVector(possibleWincards,(Card) possibleWincards.get(j)),true);
				if ( winChance > highestWinChance)
				{
						highestWinChance = winChance;
						highestWinChangeIndex = j;
				}
				if (output)
				{
					System.out.println("   Winchance!:"+((Card) possibleWincards.get(j)).getDescription()+" "+winChance);
				}
			}
			
			card = (Card) possibleWincards.get(highestWinChangeIndex);
		}*/
		
		curnumcards--;
		card.setOwner(newOwner);
		cards.remove(cards.indexOf(card));
		playedCards.add(card);
		return card;
	}
}
